#include "MAutobuses.h"

namespace MAutobuses
{     
 
    void AniadirAutobus(TAutobuses &autobuses, TAutobus autobus, bool &ok)
    {
       if (autobuses.num_buses < 5)
       {
           ok = true;                  
           autobuses.autobuses[autobuses.num_buses] = autobus;
           autobuses.num_buses++;
       }           
       else
       {
           ok = false;
       }           
    }     
    
    void ExtraerAutobus(TAutobuses &autobuses, TAutobus &autobus, bool &ok)
    {
         TNatural i;
         
         if (autobuses.num_buses == 0)
         {
            ok = false;
         }
         else
         {
            ok = true;
            autobus = autobuses.autobuses[0];
            for (i=1; i<autobuses.num_buses; i++)
            {
              autobuses.autobuses[i-1] = autobuses.autobuses[i];
            }
            autobuses.num_buses--;  
         }            
    }
         
    void LeerAutobusesFich(TAutobuses &autobuses, ifstream &fich)
    {
         TNatural i;
        
         fich >> autobuses.num_buses; 
         fich.ignore();
         for (i=0; i<autobuses.num_buses; i++)
         {
             fich >> autobuses.autobuses[i].cod_linea;
             fich.ignore();
             fich >> autobuses.autobuses[i].num_max;
             fich.ignore();
             fich >> autobuses.autobuses[i].num_actual;  
             fich.ignore();
         }    
    }     

    void EscribirAutobusesFichero(TAutobuses autobuses, ofstream &fich)
    {
         TNatural i;
         
         fich << autobuses.num_buses<< endl;
         for (i=0; i<autobuses.num_buses; i++)
         {
             fich << autobuses.autobuses[i].cod_linea << SP 
                  << autobuses.autobuses[i].num_max << SP
                  << autobuses.autobuses[i].num_actual << endl;    
         }    
    }     
    
    void SubirPasajeros(TAutobuses &autobuses, TNatural cod_linea, TNatural num, 
                        TNatural &numReal, bool &ok)
    {
         TNatural i;
         TNatural huecos;
         bool terminado;
         
         terminado = false;         
         ok = false;
         numReal =0;
         i = 0;
         while ((i<autobuses.num_buses) && !terminado)
         {
             if (autobuses.autobuses[i].cod_linea == cod_linea)
             {
                ok = true;
                huecos = autobuses.autobuses[i].num_max - autobuses.autobuses[i].num_actual;
                if (huecos < num)
                {
                   num = num - huecos;
                   numReal = numReal + huecos;
                   autobuses.autobuses[i].num_actual = autobuses.autobuses[i].num_actual + huecos;
                }
                else
                {
                    terminado = true;    
                    numReal = numReal + num;
                    autobuses.autobuses[i].num_actual = autobuses.autobuses[i].num_actual + num;
                }       
             }  
             i++;  
         }    
    }     
    
    void BajarPasajeros(TAutobuses &autobuses, TNatural cod_linea, TNatural num, 
                        TNatural &numReal, bool &ok)
    {
         TNatural i;
         
         ok = false;
         i = 0;
         numReal = 0;
         while ((i<autobuses.num_buses) && (!ok) )
         {
               if (autobuses.autobuses[i].cod_linea == cod_linea)
               {
                  ok = true;
                  numReal = num;
                  if (num > autobuses.autobuses[i].num_actual)
                  {
                     numReal = autobuses.autobuses[i].num_actual;        
                  }        
                  autobuses.autobuses[i].num_actual = autobuses.autobuses[i].num_actual - numReal;
               }                                             
               i++;
         }      
    }     
    
    void MostrarAutobuses(TAutobuses autobuses)
    {
         TNatural i;
         
         cout << autobuses.num_buses << endl;
         for (i=0; i<autobuses.num_buses; i++)
         {
             cout << autobuses.autobuses[i].cod_linea << SP 
                  << autobuses.autobuses[i].num_max << SP 
                  << autobuses.autobuses[i].num_actual << endl; 
                     
         }    
    }     
      
}      
