/*----------------------------------------------------------------
|	Autor:                                                        |
|	Fecha:                            Versin: 1.0	              |
|-----------------------------------------------------------------|
|	Descripcin del Programa:                                     |
|  								                                  |
| ----------------------------------------------------------------*/

// Incluir E/S y Libreras Standard
#include <iostream>
#include <cstdlib>
#include "MListaParadas.h"

using namespace std;
using namespace MListaParadas;

// Zona de Declaracin de Constantes
const char ENTER = '\n';
// Zona de Declaracin de Tipos

// Zona de Cabeceras de Procedimientos y Funciones
char menu();
bool Confirmar();
void MostrarError(TError err);

// Programa Principal
int main()
{
  // Zona de Declaracin de Variables del Programa principal
  char op;
  bool salir;
  TError err;
  TCadena nomFich;
  TLista l;
  unsigned int cod, linea, numSuben, numBajan, numRealS, numRealB;
  
  salir = false;
  CrearLista(l);
  
  while(!salir)
  {
    op = menu();
    cout << endl;
    err = NoError;
    
    switch(op)
    {
       case 'A': cout << "Introduzca nombre del fichero: ";
                 cin.getline(nomFich,MAXCAD,ENTER);
                 LeerParadasFichero(l, nomFich, err);
                 break;
                 
       case 'B': MostrarParadas(l);
                 break;
                 
       case 'C': cout << "Introduzca numero de parada: ";
                 cin >> cod;
                 cin.ignore();
                 BorrarParada(l,cod,err);
                 break;

       case 'D': cout << "Introduzca numero de parada: ";
                 cin >> cod;
                 cin.ignore();
                 cout << "Introduzca numero de linea: ";
                 cin >> linea;
                 cin.ignore();
                 cout << "Introduzca numero de pasajeros que bajan: ";
                 cin >> numBajan;
                 cin.ignore();
                 cout << "Introduzca numero de pasajeros que suben: ";
                 cin >> numSuben;
                 cin.ignore();
                 SubirBajarPasajeros(l,cod,linea,numSuben,numRealS,numBajan,numRealB,err);
                 if (err == NoError)
                 {
                    cout << "Han bajado del primer autobus de la linea " << linea << " " << numRealB << " pasajeros." << endl;
                    cout << "Han subido a autobuses de la linea " << linea << " " << numRealS << " pasajeros." << endl;
                 }   
                 break;

       case 'E': cout << "Introduzca numero de parada: ";
                 cin >> cod;
                 cin.ignore();
                 FueraDeServicio(l,cod,err);
                 break;
 
       case 'F': cout << "Introduzca nombre del fichero: ";
                 cin.getline(nomFich,MAXCAD,ENTER);
                 EscribirParadasFichero(l, nomFich, err);
                 break;                 
                 
       case 'X': salir = Confirmar();
                 cout << endl << endl;
                 break;    
    }
    MostrarError(err);
    system("Pause"); // Hacer una pausa
    system("cls");   // Borrar Pantalla
  }
  DestruirParadas(l);
  return 0;	   // Valor de retorno al S.O.
}

// Implementacin de Procedimientos y Funciones
char menu()
{
  char op;
  
  cout << "        MENU" << endl;
  cout << "        ====" << endl;
  cout << "Elaborado Por : <rellenar Nombre y Apellidos>>" << endl;
  cout << "E.T.S.I Informatica 1-?? Sistemas/Gestion" << endl;
  cout << "Fecha: 15 de Diciembre de 2.008" << endl;
  cout << endl;
  cout << "  A.- Leer paradas de un fichero de texto." << endl;
  cout << "  B.- Mostrar paradas." << endl;
  cout << "  C.- Borrar parada." << endl;
  cout << "  D.- Subir y bajar pasajeros." << endl;
  cout << "  E.- Poner parada fuera de servicio." << endl;
  cout << "  F.- Guardar paradas en un fichero de texto." << endl;
  cout << endl;
  cout << "  X. Salir del Programa" << endl;
  cout << endl;
  cout << "  Introduzca su opcion: " ;

  cin >> op;
  cin.ignore();
  op = toupper(op);
  
  while ( ((op<'A') || (op>'F')) && (op!='X') )
  {
    cout << "  Opcion Incorrecta ..." << endl;
    cout << endl;
    cout << "  Introduzca su opcion: " ;
    cin >> op;
    cin.ignore();
    op = toupper(op);  
  }
  
  return op;

}

bool Confirmar()
{ 
  char car;

  cout << "Esta seguro(S/N)?";
  cin >> car;
  cin.ignore();
  car = toupper(car);
  
  return (car=='S');
}

void MostrarError(TError err)
{
     switch (err)
     {
        case ErrorNoEncontrado: 
                   cout << "ERROR: La parada no ha sido encontrada" << endl;
                   break;
        case ErrorParadaExiste:
                   cout << "ERROR: La parada ya existe" << endl;
                   break;
        case ErrorAperturaFichero:
                   cout << "ERROR: No ha sido posible abrir el fichero" << endl;
                   break;
        case ErrorCrearFichero:
                   cout << "ERROR: No ha sido posible crear el fichero" << endl;
                   break;
        case ErrorLineaNoExiste:
                   cout << "ERROR: La linea de autobuses no existe" << endl;
                   break;
        case ErrorNoHayEspacio:
                   cout << "ERROR: No se ha borrado la parada. No se han podido mover todos los autobuses" << endl;           
        case NoError:
                   cout << "Operacion realizada correctamente" << endl;
                   break; 
     }
}
